#!/usr/local/bin/perl 

#Copyright 1997 Vectaport Inc.
#Copyright 1996 Cider Press
#
#This file is part of ivmkcm.
#
#This program is free software; you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation; either version 2 of the License, or
#(at your option) any later version.

#This program is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.

#You should have received a copy of the GNU General Public License
#along with this program; if not, write to the Free Software
#Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#####################################################################################

# cmadd - add a source file(s) to a module

#####################################################################################

$synopsis = "cmadd [-m \"message\"] [filename]";

#resolve CVSROOT

if (-d "./CVS") {
    $repfiles = "*";
    if (open(REPOSITORYFILE, "./CVS/Repository")) {
	$rep = <REPOSITORYFILE>; ($module = $rep) =~ s#.*/##;
	chop($module); 
    }
    if (open(ROOTDIRFILE, "./CVS/Root")) {
	$rootdir = <ROOTDIRFILE>; chop($rootdir);
	$ENV{CVSROOT} = $rootdir;
	print "Using $rootdir as repository root for $module module.\n";
    } else {
	$cmpathraw = $ENV{"CMPATH"}; ($cmpath = $cmpathraw) =~ s/:/ /g;
	foreach $rootdir (<${cmpath}>) {
            if (-d "$rootdir/$module") {
	        $ENV{CVSROOT} = $rootdir;
	        print "Using $rootdir as repository root for $module module.\n";
		last;
            }
        }
    }

    if ($#ARGV == -1) {
	if ($r = $ENV{"REPOSITORY_FILES"}) {
            $repfiles = $r;
        }
	foreach $file (<${repfiles}>) {
	    if (! -e "$rootdir/$module/$file,v" && -e "./$file") {
		print( "A $file\n");
	        system("cvs -Q add $file");
	    }
	}
    } elsif ($#ARGV == 0) {
        if ($ARGV[0] eq "-m") {
            print "Incorrect usage\n";
            print "Usage: $synopsis\n";
        } else {
	    if (-e $ARGV[0]) {
		print( "A $ARGV[0]\n");
                system("cvs -Q add $ARGV[0]");
	    } else {
		print "Cannot access $ARGV[0]: No such file or directory\n";
	    }
        }
    } elsif  ($#ARGV == 1 && $ARGV[0] eq "-m") {
        if ($r = $ENV{"REPOSITORY_FILES"}) {
	    $repfiles = $r;
	}
	foreach $file (<${repfiles}>) {
	    if (! -e "$rootdir/$module/$file,v" && -e "./$file") {
		print( "A $file\n");
	        system("cvs -Q add -m $ARGV[1] $file");
	    }
	}

    } elsif  ($#ARGV == 2 && $ARGV[0] eq "-m") {
	if (-e $ARGV[2]) {
	    print( "A $ARGV[2]\n");
            system("cvs -Q add -m $ARGV[1] $ARGV[2]");
        } else {
	    print "Cannot access $ARGV[2]: No such file or directory\n";
        }

    } else {
        print "Incorrect usage\n";
        print "Usage: $synopsis\n";
    }
} else {
    print "Cannot access ./CVS: No such file or directory\n";
}
