#!/usr/local/bin/perl 

# Copyright 1997 Vectaport Inc.
# Copyright 1995-1996 Cider Press
#
# This file is part of ivmkcm.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#####################################################################################

# cmchkin - create a new repository, check in the source files in the 
# current directory, and convert the current directory into a checked out
# module

#####################################################################################

$synopsis = "cmchkin module repository [top_dir] [cur_dir]";

require "ctime.pl";
$date = &ctime(time);

format OUT =
@<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
$out
.

if ($#ARGV >= 1 && -d $ARGV[1]) {
    if (! -d "$ARGV[1]/$ARGV[0]") {
      	print "Making $ARGV[0] module in $ARGV[1].\n";

      	mkdir ("$ARGV[1]/$ARGV[0]", 755); chmod 0755, "$ARGV[1]/$ARGV[0]";
      	mkdir ("$ARGV[1]/Patches/$ARGV[0]", 755); chmod 0755, "$ARGV[1]/Patches/$ARGV[0]";

	open(OUT, ">$ARGV[1]/Patches/$ARGV[0]/PatchLevel") ||
   	    die "Cannot open $ARGV[1]/Patches/$ARGV[0]/PatchLevel\n";
	$out = 0;
	write(OUT);
	close(OUT);

	open(OUT, ">$ARGV[1]/Patches/$ARGV[0]/CommitLevel") ||
            die "Cannot open $ARGV[1]/Patches/$ARGV[0]/CommitLevel\n";
	$out = 0;
	write(OUT);
	close(OUT);

	open(OUT, ">$ARGV[1]/ChangeLog/$ARGV[0]") || 
            die "Cannot open $ARGV[1]/ChangeLog/$ARGV[0]\n";
	$out = "*** cmchkin of $ARGV[0] module on $date";
	write(OUT);
	$out = "/n";
	write(OUT);
	close(OUT);

	if ($#ARGV == 3 ) {
	    open(OUT, ">>$ARGV[1]/CVSROOT/editpkg.sed") || 
		die "Cannot open $ARGV[1]/CVSROOT/editpkg.sed\n";
	    if ($ARGV[2] eq $ARGV[3]) {
	       $dir = "."
            } else {
	       $dir = substr($ARGV[3], length($ARGV[2])+1);
            }
	    $out = "s:^--- $ARGV[0]/:--- $dir/:";
	    write(OUT);
	    close(OUT);
	}

	open(OUT, ">>$ARGV[1]/CVSROOT/loginfo") || 
            die "Cannot open $ARGV[1]/CVSROOT/loginfo\n";
	$out = "^$ARGV[0]\$ cat>/tmp/$ARGV[0].changes";
	write(OUT);
	close(OUT);

        mkdir("./$ARGV[0]",755); chmod 0755, "./$ARGV[0]";
        chdir("./$ARGV[0]");
      	system("cvs -d $ARGV[1] import -m \" $ARGV[0] module checked in by $USER \" $ARGV[0] REPVENDORTAG VENDORELTAG");
        chdir("..");

	rmdir("./$ARGV[0]");
	system ("cmcopy $ARGV[0] $ARGV[1]");
	rename("./$ARGV[0]/CVS","./CVS");
	rmdir("./$ARGV[0]");

	system("cmadd -m null_message");
        
        system("cmcommit -q -m commit0");

      	print "Checkin process is complete.\n";
    }
    else {
	if (! -d $ARGV[1]) {
	    print "Cannot access $ARGV[1]: No such file or directory\n";	    
	}
        if (-d "$ARGV[1]/$ARGV[0]") {
	    print "$ARGV[0] already exists in $ARGV[1] repository!\n!"
	}
     }
}
else {
    print "Incorrect usage\n";
    print "Usage: $synopsis\n";
}
