#!/usr/local/bin/perl 

# Copyright 1997 Vectaport Inc.
# Copyright 1996 Cider Press
# Copyright 1994-1996 Vectaport Inc.
#
# This file is part of ivmkcm.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#####################################################################################

# cmcommit - commit changes to the repository

#####################################################################################

$synopsis = "commit [-q] [-m msg] [filename]";
$commited = 0;
$quiet = 0;

require "ctime.pl";
$date = &ctime(time);

format OUT =
@<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
$out
.

#resolve CVSROOT
if (-d "./CVS") {
    print "commiting...\n";
    $repfiles = "*";
    if (open(REPOSITORYFILE, "./CVS/Repository")) {
	$rep = <REPOSITORYFILE>; ($module = $rep) =~ s#.*/##;
	chop($module); 
    }
    if (open(ROOTDIRFILE, "./CVS/Root")) {
	$rootdir = <ROOTDIRFILE>; chop($rootdir);
	$ENV{CVSROOT} = $rootdir;
	print "Using $rootdir as repository for $module module.\n";
    } else {
	$cmpathraw = $ENV{"CMPATH"}; ($cmpath = $cmpathraw) =~ s/:/ /g;
	foreach $rootdir (<${cmpath}>) {
            if (-d "$rootdir/$module") {
	        $ENV{CVSROOT} = $rootdir;
	        print "Using $rootdir as repository for $module module.\n";
		last;
            }
        }
    }

    #resolve tagname
    open(IN, "$rootdir/Patches/$module/CommitLevel") 
	|| die "Cannot open $rootdir/Patches/$module/CommitLevel\n";

    while (<IN>) {
	$commitlevel = $_; chop $commitlevel;
	last;
    }
    close(IN);

    $tagname = "commit$commitlevel";

    #process command line
    if ($#ARGV == -1) {
	system("cvs commit -l");
	$commited = 1;

    } elsif ($#ARGV == 0) {
        if (-e "./$ARGV[0]" && $ARGV[0] ne "-q") {
            system("cvs commit -l $ARGV[0]");
	    $commited = 1;
	} else {
	    print "Cannot access $ARGV[0]: No such file or directory\n";
        }
	if ($ARGV[0] eq "-q") {
            system("cvs -Q commit -l");
	    $commited = 1;
	    $quiet = 1;
	} else {
            print "Incorrect usage\n";
            print "Usage: $synopsis\n";
	}

    } elsif ($#ARGV == 1) {
        if ($ARGV[0] eq "-q") {
	    if (-e "./$ARGV[1]") {
                system("cvs -Q commit -l $ARGV[1]");
	        $commited = 1;
	        $quiet = 1;
	    } else {
	        print "Cannot access $ARGV[1]: No such file or directory\n";
	    }
        } elsif ($ARGV[0] eq "-m") {
            system("cvs commit -l -m \" $ARGV[1] \" ");
	    $commited = 1;
	} else {
            print "Incorrect usage\n";
            print "Usage: $synopsis\n";
	}	    

    } elsif ($#ARGV == 2) {
        if ($ARGV[0] eq "-m") {
	    if (-e "./$ARGV[2]") {
                system("cvs commit -l -m \" $ARGV[1] \" $ARGV[2]");
		$commited = 1;
	    } else {
	        print "Cannot access $ARGV[2]: No such file or directory\n";
            }
	} elsif ($ARGV[0] eq "-q" && $ARGV[1] eq "-m") {
            system("cvs commit -l -m \" $ARGV[1] \" ");
   	    $commited = 1;
	    $quiet = 1;
	} else {
            print "Incorrect usage\n";
            print "Usage: $synopsis\n";
	}	    

    } elsif ($#ARGV == 3) {
        if ($ARGV[0] eq "-q") {
	    if (-e "./$ARGV[3]") {
                system("cvs -Q commit -l -m \" $ARGV[2] \" $ARGV[3]");
		$commited = 1;
	        $quiet = 1;
	    } else {
	        print "Cannot access $ARGV[3]: No such file or directory\n";
            }
	} else {
            print "Incorrect usage\n";
            print "Usage: $synopsis\n";
	}	    

    } else {
        print "Incorrect usage\n";
        print "Usage: $synopsis\n";
    }

    # update the ChangeLog file
    if ($commited) {
        # if (-e "/tmp/$module.changes") {
        if (1) {

	    # capture the OrigChangeLog
            open(IN, "$rootdir/ChangeLog/$module") || 
		die "Cannot open $rootdir/ChangeLog/$module\n";
	    open(OUT, ">/tmp/$module.OrigChangeLog") || 
		die "Cannot open /tmp/$module.OrigChangeLog\n";
	    $~ = OUT;
	    while (<IN>) {
	        $out = $_;
	        write(OUT);
	    }
	    close(IN);
	    close(OUT);

	    # get the user id
	    $userid = (stat("/tmp/$module.OrigChangeLog"))[4];

	    # create new HeadChangeLog
	    open(OUT, ">/tmp/$module.HeadChangeLog") || 
		die "Cannot open /tmp/$module.OrigChangeLog\n";
            $out = "\n*** $tagname of $module module by $userid on $date ***\n";
            write(OUT);
	    close(OUT);

	    # put HeadChangeLog, $module.changes and OrigChangeLog
	    # together in $rootdir/ChangeLog/$module
            open(IN, "/tmp/$module.HeadChangeLog") || 
		die "Cannot open /tmp/$module.HeadChangeLog\n";
	    open(OUT, ">$rootdir/ChangeLog/$module") || 
		die "Cannot open $rootdir/ChangeLog/$module\n";
	    $~ = OUT;
	    while (<IN>) {
	        $out = $_;
	        write(OUT);
	    }
	    close(IN);
	    close(OUT);

            open(IN, "/tmp/$module.changes") || 
		exit "nothing changed\n";
	    open(OUT, ">>$rootdir/ChangeLog/$module") ||
		die "Cannot open $rootdir/ChangeLog/$module\n";
	    $~ = OUT;
	    while (<IN>) {
	        $out = $_;
	        write(OUT);
	    }
	    close(IN);

            open(IN, "/tmp/$module.OrigChangeLog") || 
		die "Cannot open /tmp/$module.OrigChangeLog\n";
	    while (<IN>) {
	        $out = $_;
	        write(OUT);
	    }
	    close(IN);
	    close(OUT);

	    # clean up /tmp
	    unlink("/tmp/$module.changes",
		   "/tmp/$module.OrigChangeLog", 
		   "/tmp/$module.HeadChangeLog");

	    # tag the module
	    print "tagging with $tagname... ";
            system("cvs -Q rtag $tagname $module");

	    # update the commitlevel and make a patch if -q is *not* specified
	    $prevlevel = $commitlevel;
            if ($prevlevel > 0) {
		--$prevlevel;
	        if ($quiet != 1) {
		    system("cmmkpatch $rootdir/Patches/$module/$tagname commit$prevlevel $tagname $module");
	        } 
            } else {
                if ($quiet != 1) {
	            system("cmmkpatch $rootdir/Patches/$module/$tagname nothing $tagname $module");
	        }
            }

            ++$commitlevel;
	    open(OUT, ">$rootdir/Patches/$module/CommitLevel") || 
		die "Cannot open $rootdir/Patches/$module/CommitLevel\n";
            $out = $commitlevel;
            write(OUT);
	    close(OUT);
	  print " succeeded.\n";

        } else {
	    print "nothing to commit.\n";
        }
    } else {
	  print "failed.\n";
    }
} else {
    print "Cannot access ./CVS: No such file or directory\n";
}
