#!/usr/local/bin/perl 

# Copyright 1997 Vectaport Inc.
# Copyright 1996 Cider Press
# Copyright 1994-1996 Vectaport Inc.
#
# This file is part of ivmkcm.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#####################################################################################

# cmcopy - create a module in the current directory from the repository

#####################################################################################

$synopsis = "cmcopy [-t tagname] module [repository]";

format OUT =
@<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
$out
.

$resolved = 0;
$cmpathraw = $ENV{"CMPATH"}; ($cmpath = $cmpathraw) =~ s/:/ /g;

if ($#ARGV == -1) {
    print "Incorrect usage\n";
    print "$synopsis\n";

} elsif ($#ARGV == 0) {
    foreach $rootdir (<${cmpath}>) {
        if (-d "$rootdir/$ARGV[0]") {
            $ENV{CVSROOT} = $rootdir;
            print "Using $rootdir as repository for $ARGV[0] module.\n";
            $resolved = 1;
    	    last;
        }
    }
    if ($resolved) {
	system("cvs checkout $ARGV[0]");
    } else {
	print "Could not find $ARGV[0] module in any of:\n$cmpathraw\n";
    }
} elsif ($#ARGV == 1) {
    if (-d $ARGV[1]) {
        $ENV{CVSROOT} = $ARGV[1];
        print "Using $ARGV[1] as repository for $ARGV[0] module.\n";
	system("cvs checkout $ARGV[0]");
#        if (-d $ARGV[0]) {
#	    open(OUT, ">$ARGV[0]/CVS/Root") ||
#            die "Cannot open $ARGV[0]/CVS/Root\n";
#	    $out = "$ARGV[1]";
#	    write(OUT);
#	    close(OUT);
#	}
    } else {
        die "Cannot access $ARGV[1]: No such file or directory\n";
    }
} elsif ($#ARGV == 2) {
    foreach $rootdir (<${cmpath}>) {
        if (-d "$rootdir/$ARGV[2]") {
            $ENV{CVSROOT} = $rootdir;
            print "Using $rootdir as repository for $ARGV[0] module.\n";
            $resolved = 1;
    	    last;
        }
    }
    if ($resolved) {
	if ($ARGV[0] eq "-t") {
	    system("cvs checkout -r $ARGV[1] $ARGV[2]");
	} else {
	    print "Incorrect usage\n";
	    print "Usage: $synopsis\n";
	}
    } else {
	print "Could not find $ARGV[0] module in any of:\n$cmpathraw\n";
    }

} elsif ($#ARGV == 3) {
    if (-d $ARGV[3]) {
        $ENV{CVSROOT} = $ARGV[3];
        print "Using $ARGV[3] as repository for $ARGV[2] module.\n";
	if ($ARGV[0] eq "-t") {
	    system("cvs checkout -r $ARGV[1] $ARGV[2]");
	} else {
	    print "Incorrect usage\n";
	    print "Usage: $synopsis\n";
	}
        if (-d $ARGV[0]) {
	    open(OUT, ">$ARGV[0]/CVS/Root") ||
            die "Cannot open $ARGV[0]/CVS/Root\n";
	    $out = "$ARGV[1]";
	    write(OUT);
	    close(OUT);
	}
    } else {
        die "Cannot access $ARGV[3]: No such file or directory\n";
    }

} else {
    print "Incorrect usage\n";
    print "Usage: $synopsis\n";
}
