#!/usr/local/bin/perl 

# Copyright 1997 Vectaport Inc.
# Copyright 1995-1996 Cider Press
#
# This file is part of ivmkcm.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. 

#####################################################################################

# cminstall - create a root repository

#####################################################################################

$synopsis = "cminstall";

format OUT =
@<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
$out
.

$BINDIR = "/usr/local/bin";

if ($#ARGV >= 0) {
    print "Incorrect usage\n";
    print "Usage: $synopsis\n";
    print "Ignoring extraneous arguments...\n";
    print "\n";
}

print "\n";
print "Installing repository root... ";
mkdir("cm", 0755);
mkdir ("cm/CVSROOT", 0755);
print "done.\n";
print "\n";

print "Populating the cm/CVSROOT directory with loginfo and modules files... ";
open(IN, "$BINDIR/loginfo") || die "Cannot open $initfiles/loginfo\n";
open(OUT, ">>cm/CVSROOT/loginfo") || die "Cannot open cm/CVSROOT/loginfo\n";
$~ = OUT;
while (<IN>) {
    $out = $_;
    write(OUT);
}
close(IN);
close(OUT);
open(IN, "$BINDIR/modules") || die "Cannot open $initfiles/modules\n";
open(OUT, ">>cm/CVSROOT/modules") || die "Cannot open cm/CVSROOT/modules\n";
$~ = OUT;

while (<IN>) {
    $out = $_;
    write(OUT);
}
close(IN);
close(OUT);
print "done.\n";
print "\n";

chdir "cm/CVSROOT" || die "Can't cd to cm/CVSROOT\n";
system 'ci -u -t-"initial loginfo file" loginfo';
system 'ci -u -t-"initial modules" modules';
chdir ".." || die "Can't cd to ..\n";
print "\n";

print "Making the ndbm(3) file for the modules database... ";
system 'mkmodules CVSROOT', '>&/dev/null';
chmod 0644, "CVSROOT/loginfo";
chmod 0644, "CVSROOT/modules";
print "done.\n";
print "\n";

mkdir("Patches", 0755);
mkdir("ChangeLog", 0755);

print "Add this new repository root to your CMPATH environment variable.\n";
print "CMPATH will be searched, in order, for module-names.\n";
print "Do not set CVSROOT in your environment.\n";
print "\n";

print "See the ivmkcm manual page for more info.\n";
