#!/usr/local/bin/perl 

# Copyright 1997 Vectaport Inc.
# Copyright 1996 Cider Press
# Copyright 1994-1996 Vectaport Inc.
#
# This file is part of ivmkcm.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#####################################################################################

# cmmkpatch - generate a patchfile between module tagnames

#####################################################################################

$synopsis = "cmmkpatch patchname fromtagname totagname module [repository]";

format OUT =
@<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
$out
.

#resolve CVSROOT
if (-d "./CVS") {
    $repfiles = "*";
    if (open(REPOSITORYFILE, "./CVS/Repository")) {
	$rep = <REPOSITORYFILE>; ($module = $rep) =~ s#.*/##;
	chop($module); 
    }
    if (open(ROOTDIRFILE, "./CVS/Root")) {
	$rootdir = <ROOTDIRFILE>; chop($rootdir);
	$ENV{CVSROOT} = $rootdir;
	
        if ($ARGV[0] ne "-") {
	    print "Using $rootdir as repository for $module module.\n";
        }
    } else {
	$cmpathraw = $ENV{"CMPATH"}; ($cmpath = $cmpathraw) =~ s/:/ /g;
	foreach $rootdir (<${cmpath}>) {
            if (-d "$rootdir/$module") {
	        $ENV{CVSROOT} = $rootdir;
                if ($ARGV[0] ne "-") {
	            print "Using $rootdir as repository for $module module.\n";
                }
		last;
            }
        }
    }
    $rootdir = $ENV{CVSROOT};

    #process command line
    if ($#ARGV < 3) {
        print "Incorrect usage\n";
        print "Usage: $synopsis\n";

    } elsif ($#ARGV == 3) {
	if ($ARGV[0] ne "-") {
	    print "Generating $ARGV[0] patch from $ARGV[1] to $ARGV[2]...\n";
	}

	#extract relevant portion of ChangeLog
        open(IN, "$rootdir/ChangeLog/$ARGV[3]") || 
   	    die "Cannot open $rootdir/ChangeLog/$ARGV[3]\n";
	open(OUT, ">/tmp/cmmkpatch-$ARGV[3]-$ARGV[2]") || 
	    die "Cannot open /tmp/cmmkpatch-$ARGV[3]-$ARGV[2]\n";

	if ($ARGV[2] eq "commit0") {
            $ok = 0;
	    while (<IN>) {
		$out = $_;
		if (/^\*\*\* $ARGV[2]/ || $ok) {
		    $ok = 1;
		    if (/^\*\*\* cmchkin/) {
			last;
		    } else {
			write(OUT);
		    }
		}
	    }

	} else {
            $ok = 0;
	    while (<IN>) {
		$out = $_;
		if (/^\*\*\* $ARGV[2]/ || $ok) {
		    $ok = 1;
		    if (/^\*\*\* $ARGV[1]/) {
			last;
		    } else {
			write(OUT);
		    }
		}
	    }
        }
        close(IN);
        close(OUT);

	#print to screen or move ChangeLog info to current directory and clean up
	if (-e "/tmp/cmmkpatch-$ARGV[3]-$ARGV[2]") {
	    if ($ARGV[0] eq "-") {
	  	system("cat /tmp/cmmkpatch-$ARGV[3]-$ARGV[2]");

            } else {
		open(IN, "/tmp/cmmkpatch-$ARGV[3]-$ARGV[2]") || 
		    die "Cannot open /tmp/cmmkpatch-$ARGV[3]-$ARGV[2]\n";
		open(OUT, ">$ARGV[0]") || die "Cannot open $ARGV[0]\n";
		$~ = OUT;
		while (<IN>) {
		    $out = $_;
		    write(OUT);
		}
		close(IN);
		close(OUT);
            }
   	    unlink("/tmp/cmmkpatch-$ARGV[3]-$ARGV[2]");
        }

	#generate the context diffs
        if ($ARGV[0] eq "-") {
	    if (-e "$rootdir/CVSROOT/editpkg.sed") {
	        system("cvs -Q patch -r$ARGV[1] -r$ARGV[2] $ARGV[3] | sed -f $rootdir/CVSROOT/editpkg.sed");
	    } else {
	        system("cvs -Q patch -r$ARGV[1] -r$ARGV[2] $ARGV[3]");
            }

        } else {
	    if (-e "$rootdir/CVSROOT/editpkg.sed") {
 	        system("cvs -Q patch -r$ARGV[1] -r$ARGV[2] $ARGV[3] | sed -f $rootdir/CVSROOT/editpkg.sed >> $ARGV[0]");
            } else {
	        system("cvs -Q patch -r$ARGV[1] -r$ARGV[2] $ARGV[3] >> $ARGV[0]");
	    }   
        }

    } elsif ($#ARGV == 4) {

    } else {
        print "Incorrect usage\n";
        print "Usage: $synopsis\n";
    }

} else {
    print "Cannot access ./CVS: No such file or directory\n";
}
