#!/usr/local/bin/perl 

# Copyright 1997 Vectaport Inc.
# Copyright 1996 Cider Press
# Copyright 1994-1996 Vectaport Inc.
#
# This file is part of ivmkcm.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#####################################################################################

# cmtag - compare file to the repository

#####################################################################################

$synopsis = "cmtag tagname [module] [repository]";

#process command line
if ($#ARGV == -1) {
    print "Incorrect usage\n";
    print "Usage: $synopsis\n";

} elsif ($#ARGV == 0) {
    if (-d "./CVS") {
        $repfiles = "*";
        if (open(REPOSITORYFILE, "./CVS/Repository")) {
	    $rep = <REPOSITORYFILE>; ($module = $rep) =~ s#.*/##;
	    chop($module); 
        }
        if (open(ROOTDIRFILE, "./CVS/Root")) {
	    $rootdir = <ROOTDIRFILE>; chop($rootdir);
	    $ENV{CVSROOT} = $rootdir;
	    print "Using $rootdir as repository for $module module.\n";
        } else {
	    $cmpathraw = $ENV{"CMPATH"}; ($cmpath = $cmpathraw) =~ s/:/ /g;
	    foreach $rootdir (<${cmpath}>) {
                if (-d "$rootdir/$module") {
	            $ENV{CVSROOT} = $rootdir;
	            print "Using $rootdir as repository for $module module.\n";
		    last;
                }
            }
        }

        print "Tagging $module with $ARGV[0]...\n";
        system("cvs rtag $ARGV[0] $module");

    } else {
        die "Cannot access ./CVS: No such file or directory\n";
    }

} elsif ($#ARGV == 1) {
    $rootdirfound = 0;
    $cmpathraw = $ENV{"CMPATH"}; ($cmpath = $cmpathraw) =~ s/:/ /g;
    foreach $rootdir (<${cmpath}>) {
        if (-d "$rootdir/$ARGV[1]") {
            $ENV{CVSROOT} = $rootdir;
	    print "Using $rootdir as repository for $ARGV[1] module.\n";
	    $rootdirfound = 1;
	    last;
        }
    }

    if ($rootdirfound) {
        print "Tagging $ARGV[1] with $ARGV[0]...\n";
        system("cvs rtag $ARGV[0] $ARGV[1]");

    } else {
        die "Cannot resolve repository from CMPATH\n";
    }

} elsif ($#ARGV == 2) {
    if (-d "$ARGV[2]") {
        print "Using $ARGV[2] as repository for $ARGV[1] module.\n";
    } else {
        die "Cannot access $ARGV[2]: No such file or directory\n";
    }
    if (-d "$ARGV[2]/$ARGV[1]") {
        print "Tagging $ARGV[1] with $ARGV[0]...\n";
        system("cvs -d $ARGV[2] rtag $ARGV[0] $ARGV[1]");
    } else {
	die "Cannot access $ARGV[1]: No such file or directory\n";
    }

} else {
    print "Incorrect usage\n";
    print "Usage: $synopsis\n";
}
